/*
 * Fahrplan.java
 *
 * Created on 8. Juni 2007, 16:10
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package guettingen;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.GregorianCalendar;
import java.util.Timer;
import java.util.TimerTask;

public class Fahrplan {
	class ZugSender extends TimerTask {
		public ZugSender(boolean l, int ln) {
			links = l;
			laenge = ln;
		}
		
		public void run() {
			if (links) Hauptfenster.anz.bf[0].sendeZug(laenge);
			else Hauptfenster.anz.bf[1].sendeZug(laenge);
		}
		
		int laenge;
		boolean links;
	}
	
	public Fahrplan() {
//		timer = new Timer("Timer", true);
	}
	
	public void laden(File f) throws IOException
	{
		//			 0123456789
		// Format des Fahrplans: HHMM R LLL
		
		BufferedReader br;
		String line;
		int h, m, laenge;
		boolean von_links;
		GregorianCalendar gc;
		int ch, cm, cs;
		long delay;
		
		if (timer != null) {
			timer.cancel();
			timer = null;
		}
		
		timer = new Timer(true);
		
		br = new BufferedReader(new FileReader(f));

		gc = new GregorianCalendar();
		ch = gc.get(GregorianCalendar.HOUR_OF_DAY);
		cm = gc.get(GregorianCalendar.MINUTE);
		cs = gc.get(GregorianCalendar.SECOND);
		
		while (true) {
			line = br.readLine();
			
			if (line == null) {
				br.close();
				return;
			}
			
			if (line.isEmpty()) continue;
			
			h = Integer.valueOf(line.substring(0, 2));
			m = Integer.valueOf(line.substring(2, 4));
			if (line.charAt(5) == 'K') von_links = true;
			else if (line.charAt(5) == 'A') von_links = false;
			else continue;
			
			laenge = Integer.valueOf(line.substring(7, 10));
			
			delay = 3600000 * (h - ch) + 60000 * (m - cm) - 1000 * cs;
			if (delay <= 0) continue;
			
			timer.schedule(new ZugSender(von_links, laenge), delay);
		}
	}
	
	public void abbrechen()
	{
		timer.cancel();
		timer = null;
	}
	
	Timer timer;
}
