/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

public class SpurElement {
	public int signalStellung(boolean richtung) {
		if (richtung) {
			if (rechts == null) return 0;
			if (rechts.links != this) return 0;
			return rechts.signalStellung(true);
		} else {
			if (links == null) return 0;
			if (links.rechts != this) return 0;
			return links.signalStellung(false);
		}
	}
	
	public int signalDistanz (boolean richtung, int pos) {
		int dist;
		if (richtung) {
			if (rechts == null) return laenge - pos;
			dist = laenge - pos;
			dist += rechts.signalDistanz (true, 0);
		} else {
			if (links == null) return pos;
			dist = pos;
			dist += links.signalDistanz (false, links.laenge);
		}
		return dist;
	}

	public final void initRoute (SpurElement l, SpurElement r, int len) {
		links = l;
		rechts = r;
		laenge = len;
	}
	
/*
	
	public SpurElement next(boolean richtung) {
		if (richtung) return rechts;
		else return links;
	}
*/
	public void belegen () {
//		System.out.println ("SpurElement belegt");
		belegt = true;
		synchronized (Ueberwachung.thread) {
			Ueberwachung.thread.notify();
		}
	}
	
	public void freigeben () {
//		System.out.println ("SpurElement frei");
		belegt = false;
		synchronized (Ueberwachung.thread) {
			Ueberwachung.thread.notify();
		}
	}
	
	public boolean istBelegt() {
		return belegt;
	}
	
	SpurElement links;
	SpurElement rechts;
	int laenge;
	boolean belegt;
}
